#ifndef SCTANALYSIS_NMASKALGORITHM_H
#define SCTANALYSIS_NMASKALGORITHM_H

#include "AnalysisAlgorithm.h"

namespace SctAnalysis {
    
/**
   Algorithm for single-scan NMask Test.
   Uses a single RawScanResult to find defects in the pipeline.
*/
class NMaskAlgorithm : public AnalysisAlgorithm {
public:
    /**
       over-ride
     */
    virtual void canAddRawScanResult(const string& name) throw(Sct::LogicError, Sct::IoError);
    /**
     * over-ride
     */
    virtual boost::shared_ptr<AnalysisAlgorithm> clone(const TestData& testData, const string& moduleName) const throw();
    /**
	constructor 
     */
    NMaskAlgorithm(const TestData& testData, const string& moduleName) throw() : AnalysisAlgorithm(testData, moduleName) {}
    /** 
	destructor 
     */
    virtual ~NMaskAlgorithm() throw() {}
private:
    NMaskAlgorithm() {}
    static bool inMap;
};
}

#endif //SCTANALYSIS_NMASKALGORITHM_H
