#ifndef PIPELINEALGORITHM_H
#define PIPELINEALGORITHM_H

#include "AnalysisAlgorithm.h"

namespace SctAnalysis {
    /**
       Algorithm for single-scan Pipeline Test.
       Uses a single RawScanResult to find defects in the pipeline.
    */
class PipelineAlgorithm : public AnalysisAlgorithm {
public:
    /**
       over-ride
     */
    virtual void canAddRawScanResult(const string& name) throw(Sct::LogicError, Sct::IoError);
    /**
     * over-ride
     */
    virtual boost::shared_ptr<AnalysisAlgorithm> clone(const TestData& testData, const string& moduleName) const throw();
    /** 
	constructor 
     */
    PipelineAlgorithm(const TestData& testData, const string& moduleName) throw() : AnalysisAlgorithm(testData, moduleName) {}
    /** 
	destructor 
     */
    virtual ~PipelineAlgorithm() throw() {}
private:
    PipelineAlgorithm() {}
    static bool inMap;
};
}

#endif //PIPELINEALGORITHM_H
