#ifndef SCANLIBRARY_H
#define SCANLIBRARY_H

#include "Sct_CalibrationController.hh"
#include <boost/utility.hpp>
#include <ipc/object.h>

namespace SctCalibrationController {
namespace Ipc {
    
class ScanLibrary : public IPCCallback, public virtual Sct_CalibrationController_T_ScanLibrary, boost::noncopyable {
public:
    virtual Sct_SctApi_T_Scan * thresholdScan (Sct_CalibrationControllerStatus *_status, ilu_Cardinal nTrigs);
    virtual Sct_SctApi_T_Scan * thresholdScanfC (Sct_CalibrationControllerStatus *_status, ilu_Cardinal nTrigs, ilu_Real calCharge);
    virtual Sct_SctApi_T_Scan * strobeDelayScan (Sct_CalibrationControllerStatus *_status, ilu_Cardinal nTrigs);
    virtual Sct_SctApi_T_Scan * nmaskScan (Sct_CalibrationControllerStatus *_status, ilu_Cardinal nTrigs);
    virtual Sct_SctApi_T_Scan * tokenScan (Sct_CalibrationControllerStatus *_status);

    virtual Sct_SctApi_T_Scan& thresholdScan(unsigned long nTrigs) const = 0;
    virtual Sct_SctApi_T_Scan& thresholdScanfC(unsigned long nTrigs, double calCharge) const = 0;    
    virtual Sct_SctApi_T_Scan& strobeDelayScan(unsigned long nTrigs) const = 0;
    virtual Sct_SctApi_T_Scan& nmaskScan(unsigned long nTrigs) const = 0;    
    virtual Sct_SctApi_T_Scan& tokenScan() const = 0;
    
protected:
    ScanLibrary();
};    
}
}
#endif //SCANLIBRARY_H
