/*
 * ScriptFactory.java
 *
 * Created on 10 December 2002, 17:12
 */

package GuiComponents.scripting;
import GuiComponents.Console.*;
import org.apache.bsf.*;

/**
 * Defines a ScriptFactory that can create all necessary objects for a particular type of script.
 * @author Matthew Palmer
 */
public interface ScriptFactory {
    public BSFEngine createEngine(BSFManager manager);
    public JConsole createConsole();    
    public NameCompleter createNameCompleter(BSFEngine engine, SearchableObjectRegistry registry);
    public DefaultInterpreter createInterpreter(BSFEngine engine, JConsole console, NameCompleter nc) ;
}
