// Mainpage for Doxygen

/** @mainpage package SCTPixelDAQ
 *
 * @section intro Introduction
 *  RodCrate contains the classes for VME modules that reside in the ROD crate.
 *  At present, these are RodModule for the ROD, TimModule for the TIM and
 *  BocCard for the BOC.
 *  RodModule has a number of support classes, all of which begin with the
 *  prefix "Rod" at the start of their name. 
 *
 *  In addition, these classes rely on the VmeInterface class, which is in a
 *  sibling directory to RodCrate and which provide a C++ wrapper to the
 *  ATLAS RCCVmeInterface C library.
 *
 *  There are several sibling directories of header files that also are 
 *  referenced from RodCrate.
 *  CommonWithDsp contains the C headers for definitions needed by both the
 *  ROD Crate Controller and the ROD DSPs. 
 *  CommonForHosts contains C headers for definitions needed by the Linux and
 *  Windows NT host programs.
 *  Wrapper headers exist in RodCrate to hide some of the C syntax in these
 *  files from the C++ code.
 *
 *  Finally, a sibling directory named SlaveDspCode1 needs to exist and to contain 
 *  the four executable files needed by the slave DSPs. These four files are for
 *  IPRAM, IDRAM, EMIF registers, and external code.
 *
 *  A directory RodUtils contains various main programs used to test the
 *  functionality of RodModule, TimModule and BocCard.
 *
 * @author RodModule: Tom Meyer, Iowa State University (meyer@iastate.edu)
 * @author TimModule: John Lane, University College London (jbl@hep.ucl.ac.uk)
 * @author BocCard: John Hill, University of Cambridge (hill@hep.phy.cam.ac.uk)
 *
 *<hr>
 * @section notes  Notes for current release
 * release.notes
 *<hr>
 * @todo  Remove delay loop in writeBlockToFlashHpi when timing is understood
 * @todo  Get true block VME operations working in mdspBlockRead/Write.
 * @todo  Remove C-style casts - use polymorphic calls to VmeInterface
 * @todo  Have status() return an XML file
 * @todo  Test text buffer wrap-around
 * @todo  Test multiblock VME transfers in mdspBlockRead and mdspBlockWrite
 */
