#ifndef STREAMABLE_H
#define STREAMABLE_H

#include <string>

using std::string;

namespace Sct {

/**
Classes should implement this interface if they want to be serialized by the IO system.
For ease of implementation, all objects should be default constructible
@author Matthew Palmer	
*/
class Streamable {
public:
    /** Get the class name for this object.
    	This is used to identify the precise type.
    	@todo We could use typeid instead here, but that would
    	probably mean removing the namespace stuff.
    	@return the class name
    */
    virtual string getClassName() const throw() = 0;

    /**
      Virtual destructor to make it safe to delete through a pointer to a Streamable or any sub-class.
    */
    virtual ~Streamable() throw() {}
}
;

}

#endif //#ifndef STREAMABLE_H
