#ifndef SCT_VERSION_H
#define SCT_VERSION_H

namespace Sct {

/**
  This file contains constants that contain version info
  */   
    
extern const char* VersionString;			///< The string that contains the version info.  Should be in form SctRodDaq_x_xx_sometext
extern const unsigned int MajorVersion;			///< The major version
extern const unsigned int MinorVersion;			///< The minor version (decimal part of version * 100)
extern const double Version;				///< x_xx => x.xx
extern const char* VersionModifier;			///< the bit at the end
extern const char* BuildSystem;
extern const char* BuildHost;
extern const char* BuildDate;
extern const char* CmtConfig;
extern const char* OnlineVersion;
extern const char* RootVersion;
extern const char* GccVersion;
extern const char* RodDaqVersion;
extern const char* DataFlowVersion;


}

#endif //SCT_VERSION_H
