#include "Sct/ISProxy/ISProxy.h"
#include "Sct/ISProxy/IOManagerISProxy.h"
#include <iostream>
#include <string>

/**
This program puts an ISProxy object into a given IS server
This is handy if you want to put back a reference to one of 
the data files.

@author Matthew Palmer
*/

using namespace Sct;
using namespace Sct::IS;
using namespace Sct::ISProxy;
using namespace std;

int printHelp() {
        cout << "Usage: ProxyPublish <IS server> <class name> <uniqueID>" << endl;
        cout << "ProxyPublish puts an ISProxy into IS given appropriate information" << endl;
        cout << "This is useful if you still have the data transfer files, but the IS server has been restarted" << endl;
        cout << "The arguments should be obvious from the usage" << endl;
        return 0;
}

void publishProxy(string isServer, string className, string uniqueID) {
        IOParamsIS params(isServer);
        Sct::ISProxy::ISProxy proxy(uniqueID, className);
        IOManagerISProxy::instance().write(proxy, &params);
}


int main(int argc, char** argv) {
        if (argc != 4) return printHelp();
        try {
                publishProxy(argv[1], argv[2], argv[3]);
        } catch (Throwable& t) {
                cout << t.what() << endl;
                return 1;
        }
        return 0;
}
