/*
 * ScanHeaderTest.java
 *
 * Created on 15 September 2003, 17:03
 */

package SctData;

import junit.framework.*;
import Sct.*;
import Sct.TestFramework.*;

/**
 * Tests for the ScanHeader class
 * @author  Matthew Palmer
 */
public class ScanHeaderTest extends StreamableTestCase {
    
    public void testEquality() {
        ScanHeader h1 = new ScanHeader(1000, 50, "MyModule", new NullVariable());
        ScanHeader h2 = new ScanHeader(1000, 50, "MyModule", new NullVariable());
        assertEquals(h1, h2);
        ScanHeader h3 = new ScanHeader(1000, 50, "MyModule1", new NullVariable());
        assertFalse(h1.equals(h3));
        ScanHeader h4 = new ScanHeader(1000, 51, "MyModule", new NullVariable());
        assertFalse(h1.equals(h4));
        ScanHeader h5 = new ScanHeader(1010, 50, "MyModule", new NullVariable());
        assertFalse(h1.equals(h5));
    }
    
    public void testUniqueID() {
        ScanHeader h1 = new ScanHeader(1000, 50, "MyModule", new NullVariable());
        assertEquals(h1.getUniqueID(), "1000.50.MyModule");
    }
    
    public Streamable getStreamable() {
        return new ScanHeader(2000, 50, "MyModule", new NullVariable());
    }    
    
    protected boolean compare(Object s1, Object s2) {
        return s1.equals(s2);
    }    
    
}
