package SctData;

import Sct.*;

/**
 * This class represents all possible things what might come out of IS.
 * @author Matthew Palmer
 */
public abstract class ScanResult implements Serializable {
    /** Creates a ScanResult by referencing the header, module configuration and points*/
    public ScanResult(ScanHeader header, ModuleConfiguration moduleConfig, ScanPoints points) {
        this.header = header;
        this.moduleConfig = moduleConfig;
        this.points = points;
    }

    /** Copy constructor 
        @todo Implement this if we need it.  (Or use clone interface
     */
    public ScanResult(ScanResult scan) {
        
    }

    public ScanHeader getHeader() {
        return header;
    }

    public ModuleConfiguration getConfiguration() {
        return moduleConfig;
    }

    public ScanPoints getPoints() {
        return points;
    }
    
    protected void _read(IStream s, ObjectManager o) throws java.io.IOException {
        short version = s.readShort("Version");
        if (version != 0) throw new java.io.StreamCorruptedException("Incorrect version of ScanResult.  Expected version 0 got: " + version);
        
        header = (ScanHeader)o.readObject(s, "Header", "SctData.ScanHeader");
        points = (ScanPoints)o.readObject(s, "ScanPoints", "SctData.ScanPoints");
        moduleConfig = (ModuleConfiguration)o.readObject(s, "Configuration", "SctData.ModuleConfiguration");
    }
    
    public void write(OStream s, ObjectManager o) throws java.io.IOException {
        s.writeShort("Version", (short)0, false);
        
        o.writeObject(s, "Header", header, false);
        o.writeObject(s, "ScanPoints", points, false);
        o.writeObject(s, "Configuration", moduleConfig, false);    
    }
    
    /** For I/O use only */
    protected ScanResult(IStream s, ObjectManager o) throws java.io.IOException {
        _read(s, o);
    }

    protected ScanHeader header;
    protected ModuleConfiguration moduleConfig;
    protected ScanPoints points;
}
