#ifndef SCTDATA_IO_STROBEDELAYTESTRESULTSTREAMER_H
#define SCTDATA_IO_STROBEDELAYTESTRESULTSTREAMER_H

#include "TestResultStreamer.h"

namespace SctData {
namespace IO {

/**
 * This class allows publishing and refreshing of StrobeDelayTestResult objects to and from IS.
 * The published and refreshed elements are:
 * -> The fraction (usually 0.25) of the distance from the leading edge to the 
 * falling edge with which the optima were found.
 * -> the (usually 12 - 1 per chip) opimum values found by the analysis.
 */
class StrobeDelayTestResultStreamer : public TestResultStreamer {
public:
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
    
private:
    StrobeDelayTestResultStreamer() throw();		///< Constructor is private
    static bool inMap;					///< The static dummy variable for the IOManager map
};
}
}
#endif // #ifndef SCTDATA_IO_STROBEDELAYTESTRESULTSTREAMER_H
