#include "primListWrapper.h"

#include "RodCrate/RodModule.h"

namespace SctApi {

PrimListWrapper::PrimListWrapper() : list(new SctPixelRod::RodPrimList) {}
PrimListWrapper::PrimListWrapper(unsigned int index) : list(new SctPixelRod::RodPrimList(index)) {}

void PrimListWrapper::clear() 
{
  list->clear();
}

void PrimListWrapper::addPrimitive(const SctPixelRod::RodPrimitive &prim, long *store)
{
  list->push_back(prim);
  if(store)
    data.push_back(store);
}

PrimListWrapper::~PrimListWrapper() 
{
  for(std::list<long *>::const_iterator i = data.begin();
      i != data.end();
      i++) {
    delete [] *i;
  }
}

}
