#ifndef ArchFullBypassTestResult_H
#define ArchFullBypassTestResult_H


#include "Sct/SctNames.h"
#include "ArchTestResult.h"
#include "SctData/FullBypassTestResult.h"
#include <TVectorD.h>
#include <vector>
#include <boost/shared_ptr.hpp>


using boost::shared_ptr;
using namespace SctData;
using namespace Sct;


class ArchFullBypassTestResult: public  ArchTestResult {
  
 private:
  vector<short> status_direct;  
  vector<float> vdd_direct;
  vector<short> status_bypass;
  vector<float> vdd_bypass;

  vector< shared_ptr<TVector> > v_status_direct; 
  vector< shared_ptr<TVector> > v_vdd_direct;
  vector< shared_ptr<TVector> > v_status_bypass;
  vector< shared_ptr<TVector> > v_vdd_bypass;
  

 public: 

  ArchFullBypassTestResult();
  ArchFullBypassTestResult(FullBypassTestResult &);
  ~ArchFullBypassTestResult();
 
  void SaveFullBypassTestDataOnly();
  void SaveFullBypass();
  void TestSummary(FullBypassTestResult &);
   
};


#endif
