#ifndef ArchRawScanResult_H
#define ArchRawScanResult_H

#include <vector>
#include <is/isinfo.h>
#include "SctData/ConfigurationVariable.h"
#include "SctData/RawScanResult.h"
#include "SctData/RawScanResultIOHelper.h"
#include "Sct/SctNames.h"
#include "ArchScanResult.h"




class TFile;
class TDirectory;
class TObject;
class TSystem;
class TNamed;
class TString;
class TObjString;
class TH1;
class TH1D;
class TH2;
class TGraph;


using namespace SctData;
using namespace Sct;


class ArchRawScanResult: public ArchScanResult {
  private:
    
  //RawScanResultIOHelper Archraw;  ?????

  
  TH2D* RawData_link0;
  TH2D* RawData_link1;
  
    
  public:
    ArchRawScanResult(const RawScanResult &);
    ArchRawScanResult(); 
    ~ArchRawScanResult();
   
    void SetRawScan(RawScanResult & );

    void SaveRawScan();
    void SaveRawScan(RawScanResult& );
    bool RawScanIsPersisted(); 
    bool RawScanIsPersisted(RawScanResult& );
    bool RawScanIsPersisted(long scanNumber, long runNumber, string moduleName, const ConfigurationVariable& variable, unsigned int cycle=0);
    //void DeletePersRawObj(RawScanResult& );  //!!Problem  
    //void DeletePersRawObj();                 //!!Problem
    RawScanResult* CreateRawScanResult();
    RawScanResult* CreateRawScanResult(RawScanResult&);
    RawScanResult* CreateRawScanResult(long scanNumber, long runNumber, string moduleName, const ConfigurationVariable& variable, unsigned int cycle);

    
     void SaveRawComment();

};


#endif
