#ifndef ArchTimeWalkTestResult_H
#define ArchTimeWalkTestResult_H


#include "Sct/SctNames.h"
#include "ArchTestResult.h"
#include "SctData/TimeWalkTestResult.h"
#include <TVectorD.h>
#include <vector>
#include <boost/shared_ptr.hpp>


using boost::shared_ptr;
using namespace SctData;
using namespace Sct;


class ArchTimeWalkTestResult: public  ArchTestResult {
  
 private:
  vector<float> timewalk;
  vector<float> calibration;

  vector< shared_ptr<TVector> > v_timewalk; 
  vector< shared_ptr<TVector> > v_calibration;
 

 public: 

  ArchTimeWalkTestResult();
  ArchTimeWalkTestResult(TimeWalkTestResult &);
  ~ArchTimeWalkTestResult();
 
  void SaveTimeWalkTestDataOnly();
  void SaveTimeWalk();
  void TestSummary(TimeWalkTestResult &);
   
};


#endif
