#include "TH1.h"
#include "TH2.h"
#include "TCanvas.h"
#include "TSystem.h"
#include "SctData/ModuleConfiguration.h"
#include "SctData/ScanHeader.h"
#include "Sct/IS/IOManagerIS.h"
#include "Sct/SctNames.h"
#include "SctData/RawScanResult.h"
#include "SctData/FitScanResult.h"
#include "SctData/TestResult.h"
#include "archiving/ArchRawScanResult.h"
#include "archiving/ArchFitScanResult.h"
#include "archiving/ArchTestResult.h"
#include "archiving/ArchNoiseOccupancyTestResult.h"
#include "archiving/ArchStrobeDelayTestResult.h"
#include "archiving/ArchNPtGainTestResult.h"
#include "archiving/ArchTrimRangeTestResult.h"
//#include "archiving/ArchTestNames.h"
#include "is/isinfo.h"
#include <iostream>
#include <vector>
//#include "Sct/shared_ptr_utility.h"

using namespace Sct;
using namespace SctData;
using namespace Sct::IS;
using namespace boost;





int main(int argc, char** argv) {
	cout << "Hello?" << endl;

	//Create IS/IPC objects
	IPCPartition& p = SctNames::getPartition();
	//ISInfoIterator iter(*p, SctNames::getControlDataName(), "Test.*");
	ISInfoIterator iter(p, SctNames::getTestDataName().c_str(), "SctData::NoiseOccupancyTestResult.*");
	ISInfoIterator iter1(p, SctNames::getTestDataName().c_str(), "SctData::NPtGainTestResult.*");
	ISInfoIterator iter2(p, SctNames::getTestDataName().c_str(), "SctData::StrobeDelayTestResult.*");
	ISInfoIterator iter3(p, SctNames::getTestDataName().c_str(), "SctData::TrimRangeTestResult.*");

       	
	vector<Serializable*> ptrs;

	cout << "IS/IPC objects created, iterating" << endl;
	cout << iter.entries() << " NoiseOccupancyTestResult objects in TestData IS server" << endl;
	cout << iter1.entries() << " NPtGainTestResult objects in TestData IS server" << endl;
	cout << iter2.entries() << " StrobeDelayTestResult objects in TestData IS server" << endl;
	cout << iter3.entries() << " TrimRangeTestResult objects in TestData IS server" << endl;
	

	
	
	Archiving arch;
	arch.ListISObj();

	//Iteration over ...TestResult  TestData objects in IS:
	cout << "######Iteration over ...TestResult objects in TestData IS" << endl;
	while (iter()) {
		cout << iter.type().name() << endl;
		
		//Serializable* ob = arch.ISRetrieveObj(iter);
		cout<< " I am here " <<endl;
		shared_ptr<Serializable> ob = IOManagerIS::instance().read(iter);
		cout<< " I am here " <<endl;
		cout<< " Object retrieved: " << ob->getClassName() <<endl;

		if(ob->getClassName() == "SctData::NoiseOccupancyTestResult") {
		  cout<<" The Test Obj is NoiseOccupancyTestResult "<<endl;
		  //NoiseOccupancyTestResult* test = dynamic_cast<NoiseOccupancyTestResult*>(ob);
		  shared_ptr<NoiseOccupancyTestResult> result = dynamic_pointer_cast<NoiseOccupancyTestResult>(ob);
		}
		if(ob->getClassName() == "SctData::NPtGainTestResult") {
		  cout<<" The Test Obj is NPtGainTestResult "<<endl;
		  //NPtGainTestResult* test = dynamic_cast<NPtGainTestResult*>(ob);
		  shared_ptr<NPtGainTestResult> result = dynamic_pointer_cast<NPtGainTestResult>(ob);
		}
		if(ob->getClassName() == "SctData::StrobeDelayTestResult") {
		  cout<<" The Test Obj is StrobeDelayTestResult "<<endl;
		  //StrobeDelayTestResult* test = dynamic_cast<StrobeDelayTestResult*>(ob);
		  shared_ptr<StrobeDelayTestResult> result = dynamic_pointer_cast<StrobeDelayTestResult>(ob);
		}
		if(ob->getClassName() == "SctData::TrimRangeTestResult") {
		  cout<<" The Test Obj is TrimRangeTestResult "<<endl;
		  //TrimRangeTestResult* test = dynamic_cast<TrimRangeTestResult*>(ob);
		  shared_ptr<TrimRangeTestResult> result = dynamic_pointer_cast<TrimRangeTestResult>(ob);
		}
		else {
		  cout<< "ERROR: the object on IS is an unknown type" <<endl;
		}
		

		/*
		if (notest != 0) {
		  
		  ArchNoiseOccupancyTestResult archnotest(*notest);
		  archnotest.SetUNIXDir();
		  archnotest.SaveNoiseOccupancy();
		  
		
		} else {
		  
		  cout << "Error reading: " << iter.name() << endl;

		}

		cout << "Successfully retrieved over NoiseOccupancyTestResult objects in EventData IS" << endl;
		cout << "Next object.." << endl;
		*/

	}



	cout << "Finished" << endl;
}
