package SctApi.conf.gui;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

import java.util.Vector;

public class ModuleListView extends JFrame {
    sctConf.Configuration config;
//      ConfigGui.Module module;

    JList moduleList;

    boolean unused;

    public ModuleListView(sctConf.Configuration conf) {
        super("Module List");
//          module = mod;
        config = conf;

        unused = true;

        JPanel buttons = new JPanel();

        JCheckBox unusedCheck = new JCheckBox("Unused", unused);
        unusedCheck.addChangeListener(new ChangeListener() {
                public void stateChanged(ChangeEvent e) {
                    System.out.println("CheckBox state changed");

                    boolean tempUnused = ((ButtonModel)((JCheckBox)(e.getSource())).getModel()).isSelected();
                    System.out.println("To " + tempUnused);

                    if(tempUnused != unused) {
                        System.out.println("Updating");
                        unused = tempUnused;
                        updateList();
                    }
                }
            });
        buttons.add(unusedCheck);

        JButton addButton = new JButton("Add");
        addButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    String fileName = getFileName();

                    if(fileName != null) {
                        System.out.println("Add a module to the list using the configuration in file " + fileName);

                        try {
                            config.configureModuleFromFile(fileName);
                        } catch(sctConf.ConfigurationException ex) {
                            System.out.println("Failed!");
                        }
                    }
                }
            });
        buttons.add(addButton);

        JButton close = new JButton("Close");
        close.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
        buttons.add(close);

        getContentPane().add(buttons, BorderLayout.SOUTH);

        moduleList = new JList(getList());
        moduleList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        moduleList.setSelectedIndex(0);

        JScrollPane listScrollPane = new JScrollPane(moduleList);
        getContentPane().add(listScrollPane, BorderLayout.CENTER);
        getContentPane().validate();

        updateList();
    }

    void updateList() {
        moduleList.setListData(getList());
    }

    public Vector getList() {
        Vector result = new Vector();

        try {
            String[] modules;

            if(unused) modules = config.listUnusedModules();
            else modules = config.listAllModules();

            for(int i=0; i<modules.length; i++) {
                result.addElement(modules[i]);
                System.out.println(modules[i]);
            }

//             int[] parts = config.listPartitions();
//             for(int p=0; p<parts.length; p++) {
//                 int[] crates = config.listCratesInPartition(parts[p]);
//                 for(int c=0; c<crates.length; c++) {
//                     int[] rods = config.listRodsInCrate(parts[p], crates[c]);
//                     for(int r=0; r<rods.length; r++) {
//                         int[] MURs = config.listMURSInRod(parts[p], crates[c], rods[r]);
//                         for(int mur=0; mur<MURs.length; mur++) {
//                             String[] modules = config.listModulesInMUR(parts[p], MURs[mur]);
//                             for(int m=0; m<modules.length; m++) {
//                                 result.addElement(modules[m]);
//                             }
//                         }
//                     }
//                 }
//             }
        } catch(sctConf.ConfigurationException e) {
            System.out.println("Java caught an exception!");
        }

        System.out.println("Returned list of " + result.size() + " modules");

        return result;
    }

    /// Return selected module
    public String getSelected() {
        try {
            return (String)(moduleList.getSelectedValue());
        } finally {
            return null;
        }
    }

    static JFileChooser fileChooser;

    { fileChooser = null; }

    static String getFileName() {
        if(fileChooser == null) {
            fileChooser = new JFileChooser();
        }

        if(fileChooser.showDialog(null, "Pick module configuration file") == JFileChooser.APPROVE_OPTION) {
          java.io.File file = fileChooser.getSelectedFile();
          return file.toString();
        } else {
          return null;
        }
    }
}

