package SctApi.conf.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ModuleView extends JFrame {
    sctConf.Configuration config;
    ConfigGui.Module module;

    public ModuleView(sctConf.Configuration conf, ConfigGui.Module mod) {
        super("Module " + mod);
        module = mod;
        config = conf;

        JPanel buttons = new JPanel();

        JButton close = new JButton("Close");
        close.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
        buttons.add(close);

        getContentPane().add(buttons, BorderLayout.SOUTH);

        JPanel centre = new JPanel();

        centre.setLayout(new GridLayout(0, 1));

        centre.add(new JLabel(module.toString()));
        centre.add(new JLabel(module.getMUR()));
        centre.add(new JLabel(module.getROD()));
        centre.add(new JLabel(module.getBarrel()));
        centre.add(new JLabel(module.getPower()));

        sctConf.ABCDModule moduleConfig;
        try {
            moduleConfig = config.getModuleConfig(module.toString());

            for(int c=0; c<12; c++) {
                centre.add(new JLabel("Chip " + c));
            }

            //for(int i=moduleConfig.length - 7; i<moduleConfig.length; i++) {
            //    centre.add(new JLabel("0d" + moduleConfig[i]));
            //}
        } catch(sctConf.ConfigurationException e) {
            System.out.println("No module configuration!");
            centre.add(new JLabel("No module configuration defined!"));
       }

        getContentPane().add(centre, BorderLayout.CENTER);
    }
}
