#include "configserver.h"

using namespace std;

using namespace SctConfiguration;

int main(int argc, char** argv) 
{
  IPCCore::init(false);   // No multithreads
  IPCPartition p("SCT");
  IPCServer* server = new IPCServer(sctConf_C_Configuration_instanceName, p);

  ConfigServer *h = new ConfigServer(sctConf_C_Configuration_serverName, server);
  if (!h->publish()) {
    cout << "Failed to publish Configuration" << endl;
    return 0;
  } 
  cout << "Configuration server published, awaiting commands\n";
  try {
    server->run();
  } catch(ConfigurationException &c) {
    cout << "Configuration run threw exception " << c.what() << endl;
  }

  cout << "Run over" << endl;

  h->withdraw();
  delete h;
  delete server;
}

