package DisplayGUI;
import java.awt.event.*;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.KeyStroke;
import javax.swing.JFrame;
import javax.swing.JCheckBox;
import javax.swing.JPopupMenu;
import javax.swing.JOptionPane;
import Preferences.*;
//
import Sct.Version;
import Sct_CalibrationController.TestRequest;
import Sct_CalibrationController.SequenceRequest;
import Sct_CalibrationController.CalibrationControllerPackage.*;

import GuiComponents.System.*;
// scripting stuff
import org.apache.bsf.*;
import bsh.util.*;
import GuiComponents.scripting.*;
import GuiComponents.Console.JConsole;
import GuiComponents.System.*;

public class GuiMenuBar2 extends JMenuBar implements displayParams,ActionListener,TestDataInfo {
     gui guiControl;
     ManualConfiguration manualConfiguration;
     private SystemInterface si;
     String option;
    // scripting
    protected BSFManager manager;
    protected JConsole console;     //Only allow one!
    protected SearchableObjectRegistry registry;
    private String[] configOptionNames={"Configure","Manual Configuration..."};
    private String[] displayOptionNames={"ModuleGroup Selection","Data Manager","Test Results","SCTDB Reference Data"};

     protected ISTree isTree;
     private JMenu menu, displayMenu, ccMenu, testMenu;
     private JMenu testResultMenu, sctdbDataMenu, configMenu;
     private JMenu testDataOptionMenu, sctdbDataOptionMenu,tableDataOptionMenu, ccDataOptionMenu;
     private JMenuItem menuItem;
     private JMenuItem[] configOptions = new JMenuItem[configOptionNames.length];
     private JMenuItem[] displayOptions = new JMenuItem[displayOptionNames.length];
     private JMenuItem ccPingItem, ccRefreshItem, ccNMaskItem, ccStrobeDelayItem, ccThreePointGainItem, ccTrimItem, ccResponseCurveItem, ccNoiseItem, ccFullBypassItem, ccPipelineItem, ccTimeWalkItem;
     private JMenuItem ccCharacterisationItem;

     private JMenuItem sctapiPing, sctapiRefresh, sctapiInitialise;
     private JMenuItem[] sctapiItems = new JMenuItem[testMenuNames.length];

     private JMenuItem[] sctdbItem = new JMenuItem[3];
     private JCheckBox sctdbAutoDownload = new JCheckBox("Auto-Download enabled");
     private String[] ccUpdateStrings = {"Update","No-Update","Wait"};
     private JCheckBox[] ccUpdateModes = new JCheckBox[ccUpdateStrings.length];

     private JMenuItem scriptBeanShellItem, scriptJythonItem, scriptJavaScriptItem;
     private JMenuItem isTreeItem;
     private JCheckBox[] testFilterButtons = new JCheckBox[testMenuNames.length+1];
     private JMenu testFilterMenu;

     private JMenuItem[] testDataOptions = new JMenuItem[3];

     private JMenuItem[] preferenceItem = new JMenuItem[PreferencesInterface.getInstance().getNoPreferences()];

     private JMenuItem testReportItem;

     int itemIndex;

     public GuiMenuBar2(gui parent) {
         guiControl=parent;
         createMenuBar();
         }

    public void createMenuBar() {


        si = SystemInterface.getInstance();
//       sct = SCTInterface2.getInstance();

      
// Display menu

       displayMenu = new JMenu("Display");
       displayMenu.setBackground(backgroundColor);
       displayMenu.setFont(menuFont);
       displayMenu.setForeground(menuColor);

       configMenu = new JMenu("Configuration");
       configMenu.setFont(menuFont);
       for(int i=0;i<configOptionNames.length;i++) {
          configOptions[i] = new JMenuItem(configOptionNames[i]);
          configOptions[i].setFont(menuFont);
          configMenu.add(configOptions[i]);
          switch(i) {
            case 0:
             configOptions[i].addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayStatus.setConfigurationMode();                   
                     }
             });
             break;
            case 1:
             configOptions[i].addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                   guiControl.displayStatus.setModuleGroupSelectionMode();
                   if(manualConfiguration==null) manualConfiguration = new ManualConfiguration(guiControl);
                   else manualConfiguration.showFrame();                  
                     }
             });
            default:
            }
          }
       displayMenu.add(configMenu);
       for(int i=0;i<displayOptionNames.length;i++) {
          displayOptions[i] = new JMenuItem(displayOptionNames[i]);
          displayOptions[i].setFont(menuFont);
          switch(i) {
             case 0:  // ModuleGroup Selection
             displayOptions[i].addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                   guiControl.displayStatus.setModuleGroupSelectionMode();             
                     }
             });
             break;
             case 1:  // Data Manager
             displayOptions[i].addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                   guiControl.displayStatus.setISMode();           
                     }
             });
             break;
             case 2:   // Test Results
             displayOptions[i].addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayStatus.setTestDataMode(-1);             
                     }
             });
             break;
             case 3:    // SCTDB Data
             displayOptions[i].addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                     guiControl.displayStatus.setSCTDBDataMode(-1);          
                     }
             });
             break;
             default:
             }
          displayMenu.add(displayOptions[i]);
          displayOptions[i].setEnabled(false);
          }
       add(displayMenu);


// All tests

       testMenu = new JMenu("Tests");
       testMenu.setBackground(backgroundColor);
       testMenu.setFont(menuFont);
       testMenu.setForeground(menuColor);

       ccPingItem = new JMenuItem("Ping CalibrationController");
       ccPingItem.setFont(menuFont);
       ccPingItem.addActionListener(this);
       testMenu.add(ccPingItem);

       ccRefreshItem = new JMenuItem("Refresh CalibrationController");
       ccRefreshItem.addActionListener(this);
       ccRefreshItem.setFont(menuFont);
       testMenu.add(ccRefreshItem);

       JMenu digitalTestsMenu = new JMenu("Digital Tests");
       digitalTestsMenu.setFont(menuFont);

       ccNMaskItem = new JMenuItem("NMask");
       ccNMaskItem.setFont(menuFont);
       ccNMaskItem.addActionListener(this);
       ccNMaskItem.setEnabled(false);
       digitalTestsMenu.add(ccNMaskItem);

       ccPipelineItem = new JMenuItem("Pipeline");
       ccPipelineItem.setFont(menuFont);
       ccPipelineItem.addActionListener(this);
       ccPipelineItem.setEnabled(false);
       digitalTestsMenu.add(ccPipelineItem);

       ccFullBypassItem = new JMenuItem("FullByPass");
       ccFullBypassItem.setFont(menuFont);
       ccFullBypassItem.addActionListener(this);
       ccFullBypassItem.setEnabled(false);
       digitalTestsMenu.add(ccFullBypassItem);

       testMenu.add(digitalTestsMenu);
       JMenu analogueTestsMenu = new JMenu("Analogue Tests");
       analogueTestsMenu.setFont(menuFont);


       ccStrobeDelayItem = new JMenuItem("Strobe Delay");
       ccStrobeDelayItem.setFont(menuFont);
       ccStrobeDelayItem.addActionListener(this);
       ccStrobeDelayItem.setEnabled(false);
       analogueTestsMenu.add(ccStrobeDelayItem);

       ccThreePointGainItem = new JMenuItem("3PtGain");
       ccThreePointGainItem.setFont(menuFont);
       ccThreePointGainItem.addActionListener(this);
       ccThreePointGainItem.setEnabled(false);
       analogueTestsMenu.add(ccThreePointGainItem);

       ccTrimItem = new JMenuItem("Trim");
       ccTrimItem.setFont(menuFont);
       ccTrimItem.addActionListener(this);
       ccTrimItem.setEnabled(false);
       analogueTestsMenu.add(ccTrimItem);

       ccResponseCurveItem = new JMenuItem("ResponseCurve");
       ccResponseCurveItem.setFont(menuFont);
       ccResponseCurveItem.addActionListener(this);
       ccResponseCurveItem.setEnabled(false);
       analogueTestsMenu.add(ccResponseCurveItem);

       ccNoiseItem = new JMenuItem("Noise");
       ccNoiseItem.setFont(menuFont);
       ccNoiseItem.addActionListener(this);
       ccNoiseItem.setEnabled(false);
       analogueTestsMenu.add(ccNoiseItem);

       ccTimeWalkItem = new JMenuItem("Time Walk");
       ccTimeWalkItem.setFont(menuFont);
       ccTimeWalkItem.addActionListener(this);
       ccTimeWalkItem.setEnabled(false);
       analogueTestsMenu.add(ccTimeWalkItem);

       testMenu.add(analogueTestsMenu);
       JMenu sequencesMenu = new JMenu("Sequences");
       sequencesMenu.setFont(menuFont);

       ccCharacterisationItem = new JMenuItem("Characterisation");
       ccCharacterisationItem.setFont(menuFont);
       ccCharacterisationItem.addActionListener(this);
       ccCharacterisationItem.setEnabled(false);
       sequencesMenu.add(ccCharacterisationItem);
       
       testMenu.add(sequencesMenu);

// PseudoSCTAPI menu

       JMenu sctdaqmenu = new JMenu("SCTDAQ Exerciser");
       sctdaqmenu.setFont(menuFont);

       sctapiPing = new JMenuItem("Ping");
       sctapiPing.setFont(menuFont);
       sctdaqmenu.add(sctapiPing);
       sctapiPing.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               System.out.println(si.getTestApi().ping(""));                
            }
        });
       sctapiRefresh = new JMenuItem("Refresh");
       sctapiRefresh.setFont(menuFont);
       sctdaqmenu.add(sctapiRefresh);
       sctapiRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               si.refresh();                
            }
        });

       sctapiInitialise = new JMenuItem("Initialise");
       sctapiInitialise.setFont(menuFont);
       sctdaqmenu.add(sctapiInitialise);
       sctapiInitialise.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                 si.getTestApi().initialise();
//                 System.out.println("API initialized\n");           
            }
        });

       sctdaqmenu.addSeparator();

       for(int i=0;i<sctapiItems.length;i++) {
         if(!testIsDefined[i]) continue;
         sctapiItems[i] = new JMenuItem(testMenuNames[i]);
         sctapiItems[i].setFont(menuFont);
         sctdaqmenu.add(sctapiItems[i]);
         switch(i) {
            case TEST_FULLBYPASS:
              sctapiItems[i].addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                   guiControl.displayStatus.setTestDataMode(-1); 
                   si.getTestApi().doFullBypassScan();
//                   System.out.println("Start full bypass test via sct_api_server");   
                   if(sctdbAutoDownload.isSelected()) guiControl.sctdbDataInterface.downloadTests(TEST_FULLBYPASS);
                   }
              });
            case TEST_PIPELINE:
              sctapiItems[i].addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayStatus.setTestDataMode(-1); 
                   si.getTestApi().doPipelineScan();
//                   System.out.println("Start pipeline test via sct_api_server");   
                   if(sctdbAutoDownload.isSelected()) guiControl.sctdbDataInterface.downloadTests(TEST_PIPELINE);
                   }
              });
            break;
            case TEST_STROBEDELAY:
              sctapiItems[i].addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayStatus.setTestDataMode(-1); 
                    si.getTestApi().doStrobeDelayScan();
//                    System.out.println("Start strobe delay test via sct_api_server");
                    if(sctdbAutoDownload.isSelected()) guiControl.sctdbDataInterface.downloadTests(TEST_STROBEDELAY);
                   }
              });
             break;
            case TEST_3PTGAIN:
              sctapiItems[i].addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayStatus.setTestDataMode(-1); 
                   si.getTestApi().doThreePointGainScan();
//                    System.out.println("Start 3PtGain test via sct_api_server");
                    if(sctdbAutoDownload.isSelected()) guiControl.sctdbDataInterface.downloadTests(TEST_3PTGAIN);
                   }
              });
             break;
            case TEST_TRIM:
              sctapiItems[i].addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayStatus.setTestDataMode(-1); 
                   si.getTestApi().doTrimScan();
                   //System.out.println("Start Trim Range test via sct_api_server");
                   if(sctdbAutoDownload.isSelected()) guiControl.sctdbDataInterface.downloadTests(TEST_TRIM);
                   }
              });
             break;
            case TEST_NPTGAIN:
              sctapiItems[i].addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayStatus.setTestDataMode(-1); 
                   si.getTestApi().doResponseCurveScan();
                   //System.out.println("Start NPtGain test via sct_api_server");
                   if(sctdbAutoDownload.isSelected()) guiControl.sctdbDataInterface.downloadTests(TEST_NPTGAIN);
                   }
              });
             break;
            case TEST_NOISE:
              sctapiItems[i].addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayStatus.setTestDataMode(-1); 
                   si.getTestApi().doNoiseScan();
                   //System.out.println("Start Noise test via sct_api_server");
                   if(sctdbAutoDownload.isSelected()) guiControl.sctdbDataInterface.downloadTests(TEST_NOISE);
                   }
              });
             break;
            case TEST_TIMEWALK:
              sctapiItems[i].addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayStatus.setTestDataMode(-1); 
                   si.getTestApi().doTimeWalkScan();
                   //System.out.println("Start TimeWalk test via sct_api_server");
                   if(sctdbAutoDownload.isSelected()) guiControl.sctdbDataInterface.downloadTests(TEST_TIMEWALK);
                   }
              });
             break;
             default:
             }
         }
      testMenu.add(sctdaqmenu);
      add(testMenu);

// Options menu
       testDataOptionMenu = getTestDataOptionMenu();
       tableDataOptionMenu = getTableDataOptionMenu();
       sctdbDataOptionMenu = getSCTDBDataOptionMenu();
       ccDataOptionMenu = getCCDataOptionMenu();
       menu = new JMenu("Options");
       menu.setBackground(backgroundColor);
       menu.setFont(menuFont);
       menu.setForeground(menuColor);
       
       menu.add(tableDataOptionMenu);
       menu.add(testDataOptionMenu);
       menu.add(sctdbDataOptionMenu);
       menu.add(ccDataOptionMenu);

       add(menu);


// Tools menu
       menu = new JMenu("Tools");
       menu.setBackground(backgroundColor);
       menu.setFont(menuFont);
       menu.setForeground(menuColor);
       isTreeItem = new JMenuItem("IS Tree...");
       isTreeItem.setFont(menuFont);
       isTreeItem.addActionListener(this);
       menu.add(isTreeItem);

       JMenu menu2 = new JMenu("Scripting");
       menu2.setFont(menuFont);
       scriptJavaScriptItem = new JMenuItem("JavaScript");
       scriptJavaScriptItem.setFont(menuFont);
       scriptJavaScriptItem.addActionListener(this);
       menu2.add(scriptJavaScriptItem);
       scriptBeanShellItem = new JMenuItem("BeanShell");
       scriptBeanShellItem.setFont(menuFont);
       scriptBeanShellItem.addActionListener(this);
       menu2.add(scriptBeanShellItem);
       scriptJythonItem = new JMenuItem("Jython");
       scriptJythonItem.setFont(menuFont);
       scriptJythonItem.addActionListener(this);
       menu2.add(scriptJythonItem);
       menu.add(menu2);

       JMenuItem item = new JMenuItem("Run GarbageCollector");
       item.setFont(menuFont);
       item.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               Runtime r = Runtime.getRuntime();
               long freeMem = r.freeMemory();        
               long maxMem = r.maxMemory();
               long totalMem = r.totalMemory();
               System.out.println("Total Mem: " + totalMem/1024. + ", Max Mem:" + maxMem/1024. + " , Free Mem: " + freeMem/1024.);
               r.gc();
               try {
                 Thread.sleep(500);
               } catch (InterruptedException ie) {}
               r.gc();
               freeMem = r.freeMemory();
               maxMem = r.maxMemory();
               totalMem = r.totalMemory();
               System.out.println("Total Mem: " + totalMem/1024. + ", Max Mem:" + maxMem/1024. + " , Free Mem: " + freeMem/1024.  );
                   }
              });
       menu.add(item);
       item = new JMenuItem("Refresh Display");
       item.setFont(menuFont);
       item.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               guiControl.displayPane.setDisplayColors();
               guiControl.displayPane.refreshDisplay();
                   }
              });
       menu.add(item);
       add(menu);

// Help menu
       menu = new JMenu("Help");
       menu.setBackground(backgroundColor);
       menu.setFont(menuFont);
       menu.setForeground(menuColor);
       
       JMenuItem helpItem = new JMenuItem("View User Manual");
       helpItem.setFont(menuFont);
       menu.add(helpItem);
       helpItem.addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   guiControl.htmlViewer.show("http://www.hep.phy.cam.ac.uk/~robinson/DisplayGUI.html","Online manual");
                   }
              });
              
       JMenuItem aboutItem = new JMenuItem("About");
       aboutItem.setFont(menuFont);
       menu.add(aboutItem);
       aboutItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                String v = Version.instance.getAllInformation();
                String s = "SctGui is the user interface for end users.  See the manual for more information";                    
                s += "\nSctGui Author: Dave Robinson.";
                s += "\nSctDaqRod Authors: Alan Barr, Bruce Gallop, Matthew Palmer, Dave Robinson and Alexander Tricoli";
                s += "\n\n" + v;
                JOptionPane.showMessageDialog(guiControl, s, "About SctGui", JOptionPane.INFORMATION_MESSAGE);
            }
           });
      add(menu);

       add(javax.swing.Box.createHorizontalGlue());

// Preferences menu
       PreferencesInterface prefs = PreferencesInterface.getInstance();
       menu = new JMenu("Preferences");
       menu.setBackground(backgroundColor);
       menu.setFont(menuFont);
       menu.setForeground(menuColor);

       for(int i=0;i<prefs.getNoPreferences();i++) {
         preferenceItem[i] = new JMenuItem(prefs.getDescription(i));
         preferenceItem[i].setFont(menuFont);
         menu.add(preferenceItem[i]);
         switch(i) {
         case PreferencesInterface.INSTITUTE:
             preferenceItem[i].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   Preference preference = new Preference(guiControl,PreferencesInterface.INSTITUTE);                   
                   }
              });
              break;
         case PreferencesInterface.PSVIEWER:
             preferenceItem[i].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   Preference preference = new Preference(guiControl,PreferencesInterface.PSVIEWER);                   
                   }
              });
              break;
         case PreferencesInterface.SCRATCH_DIR:
             preferenceItem[i].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   Preference preference = new Preference(guiControl,PreferencesInterface.SCRATCH_DIR);                   
                   }
              });
              break;
         case PreferencesInterface.UPLOAD_DIR:
             preferenceItem[i].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   Preference preference = new Preference(guiControl,PreferencesInterface.UPLOAD_DIR);                   
                   }
              });
              break;
         default:
         }

         }
       add(menu);

       testFilterMenu = getTestFilterMenu();
  
       setBorder(javax.swing.BorderFactory.createEmptyBorder());
       setBackground(backgroundColor);
       }

       public void actionPerformed(ActionEvent e) {
        JMenuItem source = (JMenuItem)(e.getSource());


// CalibrationController
        if(source==ccRefreshItem) {
            si.refresh();
            return;
            }
        if(source==ccPingItem) {
            ipc.InfoHolder infoHolder = new ipc.InfoHolder();
            if (si.getCalibrationController() != null)  {
               si.getCalibrationController().get_info(infoHolder);
               ipc.Info info = infoHolder.value;
               System.out.println("CalibrationController running: " + info.pid + " by " + info.owner + " on " +info.host + " since " + info.time);
               } 
            else System.out.println("CalibrationController not running");
            return;
            }
        if(source==ccThreePointGainItem) {
              guiControl.displayStatus.setTestDataMode(-1); 
              si.getCalibrationController().doTest(si.getCalibrationController().getTestLibrary().threePointGain());
              return;
              }
        if(source==ccNMaskItem) {
              guiControl.displayStatus.setTestDataMode(-1); 
              si.getCalibrationController().doTest(si.getCalibrationController().getTestLibrary().nmask());
              return;
              }
        if(source==ccStrobeDelayItem) {
              guiControl.displayStatus.setTestDataMode(-1); 
              si.getCalibrationController().doTest(si.getCalibrationController().getTestLibrary().strobeDelay());
              return;
              }
        if(source==ccResponseCurveItem) {
              guiControl.displayStatus.setTestDataMode(-1); 
              si.getCalibrationController().doTest(si.getCalibrationController().getTestLibrary().responseCurve());
              return;
              }
	if (source==ccPipelineItem) {
              guiControl.displayStatus.setTestDataMode(-1); 
	    si.getCalibrationController().doTest(si.getCalibrationController().getTestLibrary().pipeline());
            return;
	}
	if (source==ccTimeWalkItem) {
            si.getCalibrationController().doTest(si.getCalibrationController().getTestLibrary().timeWalk());
            return;
	}
	if (source==ccFullBypassItem) {
              guiControl.displayStatus.setTestDataMode(-1); 
            si.getCalibrationController().doTest(si.getCalibrationController().getTestLibrary().fullBypass() );
            return;
	      }
	if (source==ccTrimItem) {
              guiControl.displayStatus.setTestDataMode(-1); 
            si.getCalibrationController().doTest(si.getCalibrationController().getTestLibrary().trimRange() );
            return;
	      }
	if (source==ccNoiseItem) {
              guiControl.displayStatus.setTestDataMode(-1); 
            si.getCalibrationController().doTest(si.getCalibrationController().getTestLibrary().noiseOccupancy() );
            return;
	      }       
        if(source==ccCharacterisationItem) {
              guiControl.displayStatus.setTestDataMode(-1); 
           si.getCalibrationController().doSequence(si.getCalibrationController().getSequenceLibrary().characterizationSequence());
           return;
           }        

// Scripting
        if(source==scriptBeanShellItem) {
            createScriptInterface(new BeanShellFactory());
            return;
            }        
        if(source==scriptJavaScriptItem) {
            createScriptInterface(new JavaScriptFactory());
            return;
            }
        if(source==scriptJythonItem) {
            createScriptInterface(new JythonFactory());
            return;
            }
// Tools
        if(source==isTreeItem) {
            if(isTree==null) isTree = new ISTree(guiControl,guiControl.isInterface.getISTree());
            else isTree.setTree(guiControl.isInterface.getISTree());
            return;
            }


        }

       public void enableCCMenuItems(boolean enabled) {
            ccNMaskItem.setEnabled(enabled);
	    ccPipelineItem.setEnabled(enabled);
	    ccTimeWalkItem.setEnabled(enabled);
	    ccFullBypassItem.setEnabled(enabled);
            ccStrobeDelayItem.setEnabled(enabled);
            ccThreePointGainItem.setEnabled(enabled);
            ccTrimItem.setEnabled(enabled);
            ccResponseCurveItem.setEnabled(enabled);
            ccNoiseItem.setEnabled(enabled);
            ccTimeWalkItem.setEnabled(enabled);
            ccCharacterisationItem.setEnabled(enabled);            
            }
       public void enableDisplayMenuItems(boolean enabled) {
           for(int i=0;i<displayOptionNames.length;i++) displayOptions[i].setEnabled(enabled);
           }
           

    private void initManager() {
        manager = new BSFManager();
        registry = new SearchableObjectRegistry();
        manager.setObjectRegistry(registry);
        
        try {
//            manager.declareBean("sctPanel", this, this.getClass());
            manager.declareBean("SystemInterface", si, si.getClass());
//            manager.declareBean("plotter", parent.histPlotter, parent.histPlotter.getClass());
        } catch (BSFException be) {
            System.err.println("Error initializing manager: " + be);
             }
      }
    protected void createScriptInterface(ScriptFactory sf) {
        if(manager==null) initManager();
        JConsole console = sf.createConsole();
        try {
            manager.declareBean("console",  console,  console.getClass());
        } catch (BSFException bsfe) {
            System.err.println("Internal error, BSFException whilst adding bean console.\n" + bsfe);
            bsfe.printStackTrace();
        }
        BSFEngine engine = sf.createEngine(manager);
        NameCompleter nc = sf.createNameCompleter(engine, registry);
        DefaultInterpreter di = sf.createInterpreter(engine, console, nc);        
        addNewConsole(console, di.toString());
    }
    
    /**
     * Adds the new console to this window...
     */
    protected boolean addNewConsole(JConsole console, String suffix) {    
        if (this.console != null) {
            System.err.println("Can only have 1 scripting window open at once");
            return false;
        }
        this.console = console;
        JFrame frame = new JFrame();
        frame.addWindowListener(new java.awt.event.WindowAdapter() {            
            public void windowClosing(java.awt.event.WindowEvent evt) {
                removeConsole();
            }
        });
        frame.getContentPane().add(console);  
        frame.setTitle("Scripting Window:" + suffix);
        frame.show();
        frame.setSize(400, 500);        
        return true;
    }
    
    /** 
     * Removes this JConsole
     */
    protected void removeConsole() {        
        try {
            manager.undeclareBean("console");
        } catch (BSFException bsfe) {
            System.err.println("Internal error, BSFException whilst removing bean console.\n" + bsfe);
            bsfe.printStackTrace();
        }
        console = null;
    }
   public void showCCPopupMenu(MouseEvent e) {
        JPopupMenu pMenu = ccDataOptionMenu.getPopupMenu();
        pMenu.show(e.getComponent(),e.getX(),e.getY());
        pMenu.setInvoker(ccDataOptionMenu);
        }
//**********************************************
// popup menus for tables
   public void showTablesPopupMenu(int clickedTable, MouseEvent e) {
        switch(clickedTable) {
        case 1:
          switch(guiControl.displayStatus.getStatus()) {
            case DisplayStatus.IS_MONITOR:
              JPopupMenu pMenu = tableDataOptionMenu.getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
              pMenu.setInvoker(tableDataOptionMenu);
              break;
            default:
          }
          break;
         case 0:
          switch(guiControl.displayStatus.getStatus()) {
            case DisplayStatus.TEST_DATA:
              JPopupMenu pMenu = testFilterMenu.getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
              pMenu.setInvoker(testFilterMenu);
              break;
            default:
          }
          break;
         default:
         }

        }

   public void showPopupMenu(MouseEvent e) {
        JPopupMenu pMenu;
        switch(guiControl.displayStatus.getStatus()) {
        case DisplayStatus.UNDEFINED:
           pMenu = configMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(configMenu);
           break;  
        case DisplayStatus.MODULE_GROUP_SELECTION:
           pMenu = displayMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(displayMenu);
           break;  
        case DisplayStatus.IS_MONITOR:
           pMenu = testMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(testMenu);
           break;  
        case DisplayStatus.TEST_DATA:
           pMenu = testDataOptionMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(testDataOptionMenu);
           break;
        case DisplayStatus.SCTDB_DATA:
           pMenu = sctdbDataOptionMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(sctdbDataOptionMenu);
           break;
  
        default:
           }
        }
//**************************************************
   private JMenu getTestDataOptionMenu() {
       JMenu thisMenu = new JMenu("Test Results");
       thisMenu.setFont(menuFont);
       testDataOptions[0] = new JMenuItem("ROD Data");
       testDataOptions[0].setFont(menuFont);
       testDataOptions[0].addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayPane.setDisplayOption(0);                   
                     }
             });
       testDataOptions[1] = new JMenuItem("SCTDB Reference Data");
       testDataOptions[1].setFont(menuFont);
       testDataOptions[1].addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayPane.setDisplayOption(1);                   
                     }
             });

       testDataOptions[2] = new JMenuItem("Comparison ROD-SCTDB");
       testDataOptions[2].setFont(menuFont);
       testDataOptions[2].addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    guiControl.displayPane.setDisplayOption(2);                   
                     }
             });
       thisMenu.add(testDataOptions[0]);
       thisMenu.add(testDataOptions[1]);
       thisMenu.add(testDataOptions[2]);
       return thisMenu;
       }
//**************************************************************************
    private JMenu getTableDataOptionMenu() {
       JMenu thisMenu = new JMenu("Tables");
//       thisMenu.setBackground(backgroundColor);
       thisMenu.setFont(menuFont);
//       thisMenu.setForeground(menuColor);
       thisMenu.setMnemonic(KeyEvent.VK_T);
       thisMenu.getAccessibleContext().setAccessibleDescription(
        "Table actions");

       JMenuItem item = new JMenuItem("Plot Selection");
       item.setFont(menuFont);
       item.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    switch(guiControl.displayStatus.getStatus()) {
                       case DisplayStatus.IS_MONITOR:
                          String objectname;
                          if((objectname = guiControl.tablesDisplayPane.getSelectedObject())!=null) {
                          guiControl.isInterface.launchExternalViewer(objectname);
                          }
                        break;
                    default:
                     }                                   
                 }
             });
       thisMenu.add(item);

       item = new JMenuItem("Delete Selected Test(s)");
       item.setFont(menuFont);
       item.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    switch(guiControl.displayStatus.getStatus()) {
                       case DisplayStatus.IS_MONITOR:
                         int selectedRow = guiControl.tablesDisplayPane.getSelectedTest();
                         if(selectedRow==-1) return;
                         guiControl.isInterface.removeTests(selectedRow,selectedRow); 
                         guiControl.tablesDisplayPane.updateTables();
                         break;
                       default:
                     }                                   
                 }
             });
       thisMenu.add(item);


       item = new JMenuItem("View IS Data");
       item.setFont(menuFont);
       item.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    switch(guiControl.displayStatus.getStatus()) {
                       case DisplayStatus.IS_MONITOR:
                          String objectname;
                          if((objectname = guiControl.tablesDisplayPane.getSelectedObject())!=null) {
                              guiControl.isInterface.viewISData(objectname);
                              }
                        break;
                    default:
                     }                                   
                 }
             });

       thisMenu.add(item);
       return thisMenu;
       }
//****************************************************************************************
    private JMenu getSCTDBDataOptionMenu() {
       JMenu thisMenu = new JMenu("SCTDB");
//       thisMenu.setBackground(backgroundColor);
       thisMenu.setFont(menuFont);
//       thisMenu.setForeground(menuColor);
       sctdbItem[0] = new JMenuItem("Refresh SCTDB Data");
       sctdbItem[0].setFont(menuFont);
       thisMenu.add(sctdbItem[0]);
       sctdbItem[0].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   guiControl.sctdbDataInterface.downloadTests(-1);
                   }
              });
       sctdbAutoDownload.setFont(menuFont);
       thisMenu.add(sctdbAutoDownload);
       sctdbItem[1] = new JMenuItem("SCTDB Test Location");
       sctdbItem[1].setFont(menuFont);
       thisMenu.add(sctdbItem[1]);
       sctdbItem[1].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                 java.util.Vector listOfLocations = new java.util.Vector();
                 try {
                      listOfLocations = ProdDatabase.GeneralUtilities.getLocationList();
                 }catch(Exception e2){}
                 listOfLocations.insertElementAt("Any",0);
                 guiUtilities.userPrompt thisPrompt = new guiUtilities.userPrompt(guiControl,"Any","Institute", listOfLocations);
                 thisPrompt.pack();
                 thisPrompt.setLocationRelativeTo(guiControl);
                 thisPrompt.setVisible(true);
                 String thisLocation = thisPrompt.getValidatedText();
                 if (!thisLocation.equals("None")) {
                      guiControl.sctdbDataInterface.setLocation(thisLocation);
                      guiControl.sctdbDataInterface.setTestFilter(guiControl.tablesDisplayPane.getSelectedTest());
                      guiControl.selectorPane.initParamList(); // maybe require change of parameter menu
                      guiControl.colorScalePane.setColorScale(); // ditto for color scale
                      guiControl.displayPane.setDisplayColors();
                      guiControl.displayPane.refreshDisplay();
                      guiControl.tablesDisplayPane.listTestResults();
                      }
                   
                   }
              });
       return thisMenu;
       }
//*************************************************************************************************8
   private JMenu getCCDataOptionMenu() {
       JMenu thisMenu = new JMenu("CalibrationController");
       thisMenu.setFont(menuFont);
       javax.swing.ButtonGroup thisGroup = new javax.swing.ButtonGroup();
       for(int i=0;i<ccUpdateModes.length;i++) {
         ccUpdateModes[i] = new JCheckBox(ccUpdateStrings[i]);
         thisGroup.add(ccUpdateModes[i]);
         ccUpdateModes[i].setFont(menuFont);
         thisMenu.add(ccUpdateModes[i]);
         }
       JMenuItem item = new JMenuItem("Abort");
       item.setFont(menuFont);
       item.addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   try { 
//                       System.out.println("abort of CC not yet implemented");
                       si.getCalibrationController().abort();
                       }catch(Exception eNoAbort){System.err.println("Error aborting calibrationController: "+eNoAbort.toString());}
                    }
              });    
       thisMenu.addSeparator();
       thisMenu.add(item);   
                       

       ccUpdateModes[0].setSelected(true);
       for(int i=0;i<ccUpdateModes.length;i++) {  
	   // ccUpdateModes[i].setEnabled(false);   
         switch(i) {
            case 0:
            ccUpdateModes[i].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   try {
                       si.getCalibrationController().setUpdateOption(UpdateOption.update);
                       checkCCUpdateMode();
                   }catch(Exception e){System.err.println("Error : "+e.toString());}
                   }
              });
            break;
            case 1:
            ccUpdateModes[i].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   try {
                       si.getCalibrationController().setUpdateOption(UpdateOption.noupdate);
                       checkCCUpdateMode();
                   }catch(Exception e){System.err.println("Error : "+e.toString());}
                   }
              });
            break;
            case 2:
            ccUpdateModes[i].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   try {
                       si.getCalibrationController().setUpdateOption(UpdateOption._wait);
                       checkCCUpdateMode();
                   }catch(Exception e){System.err.println("Error : "+e.toString());}
                   }
              });
            break;
            default:
            }
        }
      return thisMenu;
      }
//************************************************************************************
   public void checkCCUpdateMode() {
         if(guiControl.calibrationControllerPanel==null || guiControl.calibrationControllerPanel.status==null) {   // why is this necessary????
             System.out.println("CalibrationControllerPanel.status object not yet available... update mode not yet known");
             return;
             }
         String updateMode = guiControl.calibrationControllerPanel.status.updateOption;
         if(updateMode.equals("NOUPDATE")) ccUpdateModes[1].setSelected(true);
         else if(updateMode.equals("WAIT")) ccUpdateModes[2].setSelected(true);
         else   ccUpdateModes[0].setSelected(true);
         }

//*************************************************************************************************8
   private JMenu getTestFilterMenu() {
       JMenu thisMenu = new JMenu("Test Filter");
       thisMenu.setFont(menuFont);
       javax.swing.ButtonGroup thisGroup = new javax.swing.ButtonGroup();
       testFilterButtons[0] = new JCheckBox("All tests");
       thisGroup.add(testFilterButtons[0]);
       testFilterButtons[0].setFont(menuFont);
       testFilterButtons[0].addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(-1);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(-1); 
                     break;
                   default:
                   }           
                 }
              });
        thisMenu.add(testFilterButtons[0]);
       for(int i=1;i<testFilterButtons.length;i++) {
         if(!testIsDefined[i-1]) continue;
         testFilterButtons[i] = new JCheckBox(testNames[i-1]);
         thisGroup.add(testFilterButtons[i]);
         testFilterButtons[i].setFont(menuFont);
         thisMenu.add(testFilterButtons[i]);
         }
       testFilterButtons[0].setSelected(true);

       for(int i=1;i<testFilterButtons.length;i++) {  
         if(!testIsDefined[i-1]) continue;
         switch(i-1) { 
          case TEST_FULLBYPASS:
             testFilterButtons[i].addActionListener(new java.awt.event.ActionListener() {
               public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(TEST_FULLBYPASS);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(TEST_FULLBYPASS); 
                     break;
                   default:
                   }           
                   }
              });
            break;
          case TEST_PIPELINE:
             testFilterButtons[i].addActionListener(new java.awt.event.ActionListener() {
               public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(TEST_PIPELINE);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(TEST_PIPELINE); 
                     break;
                   default:
                   }           
                   }
              });
            break;
          case TEST_STROBEDELAY:
             testFilterButtons[i].addActionListener(new java.awt.event.ActionListener() {
               public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(TEST_STROBEDELAY);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(TEST_STROBEDELAY); 
                     break;
                   default:
                   }           
                   }
              });
            break;
          case TEST_3PTGAIN:
             testFilterButtons[i].addActionListener(new java.awt.event.ActionListener() {
               public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(TEST_3PTGAIN);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(TEST_3PTGAIN); 
                     break;
                   default:
                   }           
                   }
              });
            break;
          case TEST_TRIM:
             testFilterButtons[i].addActionListener(new java.awt.event.ActionListener() {
               public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(TEST_TRIM);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(TEST_TRIM); 
                     break;
                   default:
                   }           
                   }
              });
            break;
          case TEST_NPTGAIN:
             testFilterButtons[i].addActionListener(new java.awt.event.ActionListener() {
               public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(TEST_NPTGAIN);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(TEST_NPTGAIN); 
                     break;
                   default:
                   }           
                   }
              });
            break;
          case TEST_NOISE:
             testFilterButtons[i].addActionListener(new java.awt.event.ActionListener() {
               public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(TEST_NOISE);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(TEST_NOISE); 
                     break;
                   default:
                   }           
                   }
              });
            break;
          case TEST_TIMEWALK:
             testFilterButtons[i].addActionListener(new java.awt.event.ActionListener() {
               public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(TEST_TIMEWALK);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(TEST_TIMEWALK); 
                     break;
                   default:
                   }           
                   }
              });
            break;
          case TEST_NMASK:
             testFilterButtons[i].addActionListener(new java.awt.event.ActionListener() {
               public void actionPerformed(java.awt.event.ActionEvent evt) {
                   switch(guiControl.displayStatus.getStatus()) {
                   case DisplayStatus.TEST_DATA:
                     guiControl.displayStatus.setTestDataMode(TEST_NMASK);      
                     break;
                   case DisplayStatus.SCTDB_DATA:
                    guiControl.displayStatus.setSCTDBDataMode(TEST_NMASK); 
                     break;
                   default:
                   }           
                   }
              });
            break;
            default:
            }
          }
      return thisMenu;
      }

   public void resetTestListFilter() {
      testFilterButtons[0].setSelected(true);
      }



}
     
