package ProdDatabase;
import java.util.*;
import java.sql.*;
import java.util.zip.*;
import java.io.*;
import Preferences.*;

public class GeneralUtilities {
    public static Hashtable generalHash;

// *****************************************************************************************************************
    public static void itemExists(String sn1,String sn2,boolean resetHash) throws Exception {
      if(resetHash || generalHash==null) generalHash = new Hashtable();
      Vector itemList = new Vector();
      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("ser_no,ctype,locn_name FROM items WHERE ser_no >="+sn1+" AND ser_no <="+sn2);
      sqlStat.append(" ORDER BY ser_no");
//      System.out.println(sqlStat.toString());

      SCTDBInterface db = SCTDBInterface.getInstance();

      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      int recordCount=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         recordCount++;
         String serno = resultSet.getString(1);
          String ctype = resultSet.getString(2);
          String location = resultSet.getString(3);
          generalHash.put((String)serno,(String)ctype);
          System.out.println(serno+"("+ctype+") already exists, located at "+location);
	  }
      statement.close();
      return;
      }
//************************************************************
  public static boolean itemExists(String sn1) throws Exception {
     boolean itExists=false;
     String cType=null;
     StringBuffer sqlStat = new StringBuffer("SELECT ctype FROM items WHERE ser_no="+sn1);
      Statement statement = SCTDBInterface.getInstance().connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         cType=resultSet.getString(1);
         if(cType.indexOf("Module")!=-1) itExists=true;
         }
      statement.close();
      if(!itExists) {
         if(cType==null) javax.swing.JOptionPane.showMessageDialog(null,sn1+" does not exist in the database!","No such device",javax.swing.JOptionPane.INFORMATION_MESSAGE);
         else  javax.swing.JOptionPane.showMessageDialog(null,sn1+" is a "+cType+" (not a module)","Not a module",javax.swing.JOptionPane.INFORMATION_MESSAGE);
         }
      return itExists;
      }
         

// *****************************************************************************************************************
    public static String validateLocation(String theLocation) throws Exception {
// get location name where argument = ulocation name OR institute username OR institute user number
      String validatedLocation="unknown";
      boolean isNumber = true;
      try {
         int locationNumber = Integer.parseInt(theLocation);
      }catch(Exception nException) {isNumber=false;}

      StringBuffer sqlStat = new StringBuffer("SELECT locn_name FROM LOCNS");
      if(isNumber) sqlStat.append(" WHERE locn="+theLocation);
      else sqlStat.append(" WHERE (locn_name='"+theLocation+"' OR username='"+theLocation+"')");

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      int recordCount=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
           validatedLocation = resultSet.getString(1);
	    }
//      System.out.println("Retrieved "+recordCount+" records in total.");
      statement.close();
      return validatedLocation;
      }
// *****************************************************************************************************************
    public static String validatePersonInitial(String theUser) throws Exception {

      String person="unknown";
      StringBuffer sqlStat = new StringBuffer("SELECT initls FROM persons WHERE initls='"+theUser+"'");

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      resultSet = statement.executeQuery(sqlStat.toString());
      int recordCount=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
           person = resultSet.getString(1);
	    }
//      System.out.println("Retrieved "+recordCount+" records in total.");
      statement.close();
      return person;
      }

// ******************************************************************************************************************
    public static Vector getNameList(String location) throws Exception {
     StringBuffer sqlStat = new StringBuffer("SELECT initls FROM persons");
     sqlStat.append(" WHERE persons.locn_name LIKE '"+location+"'");

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());

     int recordCount=0;
     Vector itemList = new Vector();
     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          recordCount++;
          itemList.addElement(resultSet.getString(1));  
	    }
      System.out.println("Retrieved "+recordCount+" names in total.");

      statement.close();

      if(itemList.size()>0) return itemList;
// no users at this location? If so, return all users
      System.out.println("As there are no users defined at "+location+" I will return all users in the database.");
     sqlStat = new StringBuffer("SELECT initls FROM persons ORDER BY initls");

     statement = db.connection.createStatement();
     resultSet = statement.executeQuery(sqlStat.toString());
     recordCount=0;
     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          recordCount++;
          itemList.addElement(resultSet.getString(1));   // serial no
	    }
      statement.close();
      System.out.println("Retrieved "+recordCount+" names in total.");

      return itemList;
     }

//*****************************************************************************************
   public static Vector getRawData(String testno) throws Exception {
// get the raw data - if its a zip file, save it to disk with same filename
// otherwise just download as a string
      Vector returnData = new Vector();

      // first get filename of the raw data file of this testno

     String sqlQuery = "SELECT filename from test_rawdata WHERE test_no="+testno;
     SCTDBInterface db = SCTDBInterface.getInstance();
     Statement statement = db.connection.createStatement();
     ResultSet resultSet = statement.executeQuery(sqlQuery);
     String thisFname = null;
     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          thisFname = resultSet.getString(1);
          }
     statement.close();
     if(thisFname==null) {
          System.out.println("No raw data file found");
          return returnData;
          }
// now download that file
     File savedFile = new File(PreferencesInterface.getInstance().getPreference(PreferencesInterface.SCRATCH_DIR),thisFname);
     if(downloadFile(testno,savedFile)==0) return returnData;
// now read in the downloaded file - firat assume it is zipped...
     try {
       returnData = unZipFile(savedFile);
       }
     catch(Exception ee) {
// not zipped, so assume its just text
       returnData = getFileContent(savedFile);
       File tempFile = new File(thisFname); // get just the last part, not a pathname
       returnData.insertElementAt((String)tempFile.getName(),0);
       }
     boolean deleted = savedFile.delete(); // delete the downloaded file
// check if its an .xml file, if so, assume it is an sctdaq xml config file
// in which case, we want to lookup and susbtitute the calibrate correction factors
//     returnData = insertCalFactors(returnData);
// index0 : filename
// index1 : content as a String
// ..etc for index2 and 3 etc
     return returnData;
     }
//***********************************************************************8
public static Vector getFileContent(File theFile) throws Exception {
    // get file content as a String
    Vector returnData = new Vector();
    BufferedReader in = new BufferedReader(new FileReader(theFile));
    String line;
    StringBuffer stringBuffer = new StringBuffer();
    boolean firstLine=true;
    while((line=in.readLine())!=null) {
      if(!firstLine) stringBuffer.append("\n");
      stringBuffer.append(line);
      firstLine=false;
      }
    in.close();
    returnData.addElement(stringBuffer.toString());
    return returnData;
    }

//********************************************8
public static int downloadFile(String testno, File savedFile) throws Exception {

      InputStream in;         
      String theData = "";      
      byte[] buffer = new byte[32000]; // max size is 128kByte per image (I think!)
    FileOutputStream fos;
// execute query here
     String sqlQuery = "SELECT raw_data FROM test_rawdata WHERE test_no="+testno; 
     Statement statement = SCTDBInterface.getInstance().connection.createStatement();
     ResultSet resultSet = statement.executeQuery(sqlQuery);

     int nByteCount=0;
     fos = new FileOutputStream(savedFile);       // open the file output stream
     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         in  = resultSet.getBinaryStream(1);           // open the data stream

// read the data - will stop when reach end of stream or error, hopefully!
         for(int nbytes=in.read(buffer); nbytes>0; nbytes=in.read(buffer)){
           nByteCount += nbytes;
           fos.write(buffer,0,nbytes);
            }
         }
     fos.close();
     statement.close();
     if(nByteCount==0) System.out.println("No raw data available for test "+testno);
     else System.out.println("Downloaded "+savedFile.getName()+", size "+nByteCount+" bytes.");
     return nByteCount;
}
//*************************************************************************
public static Vector unZipFile(File savedFile) throws Exception{
      Vector returnData = new Vector();

// now extract the zip file...
     final int BUFFER=2048;
     ZipFile zFile = new ZipFile(savedFile);
     System.out.println("Unzipping raw data file, entries in zip = "+zFile.size());
     FileInputStream fis = new FileInputStream(savedFile);
     ZipInputStream zis = new ZipInputStream(new BufferedInputStream(fis));
     ZipEntry entry;
     while((entry = zis.getNextEntry()) != null) {
         returnData.addElement((String)entry.getName());   // first the data filename
         int count;
         byte[] data = new byte[BUFFER];
         StringBuffer thisData = new StringBuffer();
         while((count=zis.read(data,0,BUFFER)) != -1) {
            thisData.append(new String(data,0,count)); 
            }
         returnData.addElement((String)thisData.toString());    // then the filename content as a string
        }
     zis.close();
     return returnData;
}
//****************************************************************************
public static double get500VData(String testno) throws Exception {
     java.util.regex.Pattern i500Pattern = java.util.regex.Pattern.compile(".*500[\\.\\d]*\\s*([\\.\\d]+).*");
     java.util.regex.Pattern lastCharPattern = java.util.regex.Pattern.compile("[0-9\\.]");
     Vector thisData = getRawData(testno);
     String[] theDataString = ((String)thisData.elementAt(1)).split("[\\r\\n]");
     
     for(int i=theDataString.length-1;i>=0;i--) {
         java.util.regex.Matcher matcher = i500Pattern.matcher(theDataString[i]);
         if(matcher.matches()) {
            String data500 = theDataString[i].substring(matcher.start(1),matcher.end(1));
            return Double.parseDouble(data500);
            }
         }
      return 0.;
}

//**********************************************************************
    public static Vector getLocationList() throws Exception {
     System.out.println("Retrieving list of valid institute names from database ...");
     Statement statement = SCTDBInterface.getInstance().connection.createStatement();
     ResultSet resultSet = statement.executeQuery("SELECT locn_name FROM locns ORDER BY locn_name");
     Vector itemList = new Vector();
     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          itemList.addElement(resultSet.getString(1));   // serial no
	    }
//      System.out.println("Retrieved "+recordCount+" names in total.");
      statement.close();
      return itemList;
     }
//*************************************************************************
      public static void downloadPSFile(javax.swing.JFrame parent, java.net.URL theURL) {

      File savedFile;
      String theFileName;
      String baseName=null;
      String tryAgainURL=null;

        theFileName = theURL.getFile();
        baseName = theURL.toString();
        System.out.println("Downloading "+baseName);
        baseName = baseName.substring(0,baseName.indexOf(theFileName));
//        System.out.println("Downloading "+baseName);

        String theQuery = theURL.getQuery();
//        if(theQuery!=null) System.out.println("theQuery: "+theQuery);
        theFileName = (theQuery!=null) ? theQuery : theURL.getFile();
        int lastEquals = theFileName.lastIndexOf("=");
        if(lastEquals!=-1) theFileName = theFileName.substring(lastEquals+1);
        int lastSlash = theFileName.lastIndexOf("/");
        if(lastSlash!=-1) theFileName = theFileName.substring(lastSlash+1);

        if(!theFileName.endsWith(".ps")) theFileName+=".ps";
        savedFile = new File(PreferencesInterface.getInstance().getPreference(PreferencesInterface.SCRATCH_DIR),theFileName);
// execute query here
       try {
        downloadURL(savedFile,theURL,theFileName);
        }catch(Exception e1) {
            String eString = e1.toString();
            int nprot = eString.indexOf("no protocol: ");
            if(nprot==-1) {
                   System.out.println("Error downloading from URL: "+eString);
                   return;
                   }
            String theSubURL = eString.substring(nprot+13);
            tryAgainURL=baseName+theSubURL;
        }
     try {
     if(tryAgainURL!=null) {
        System.out.println("Invalid URL - maybe relative pathname - reconstructing new URL from relative pathname...");
        theURL = new java.net.URL(tryAgainURL);
        theFileName = theURL.getFile();
        lastSlash = theFileName.lastIndexOf("/");
        if(lastSlash!=-1) theFileName = theFileName.substring(lastSlash+1);
        int gzIndex = theFileName.indexOf(".gz");
        if(gzIndex!=-1) theFileName=theFileName.substring(0,gzIndex);
        savedFile = new File(PreferencesInterface.getInstance().getPreference(PreferencesInterface.SCRATCH_DIR),theFileName);
          

        downloadURL(savedFile,theURL,theFileName);
        }
      }catch(Exception e2) {
         System.out.println("Exception downloading from relative pathname in URL: "+e2.toString());
         return;
         }
//     theFrame.psFileList.addElement(savedFile);   //save it for deletion when application closes


     String psExecutable = PreferencesInterface.getInstance().getPreference(PreferencesInterface.PSVIEWER);
     if(psExecutable.equals("Not defined")) {
                   Preference preference = new Preference(parent,PreferencesInterface.PSVIEWER);
                   psExecutable = PreferencesInterface.getInstance().getPreference(PreferencesInterface.PSVIEWER);
                   }
     if(psExecutable.equals("Not defined")) return; // fluffed the second chance!         

     try {
         File psExec = new File(psExecutable);
         if(!psExec.exists()) return;
         String command = psExecutable+" "+savedFile.getAbsolutePath();
         System.out.println(command);
         Process p = Runtime.getRuntime().exec( command );
     } catch(Exception e2) {System.out.println("Exception invoking ps viewer: "+e2.toString());}
   }
//********************
      public static void downloadURL(File savedFile, java.net.URL theURL, String theFileName) throws Exception {
      InputStream in;              
      byte[] buffer = new byte[128000]; // max size is 128kByte per image (I think!)
      FileOutputStream fos;
      int nByteCount=0;

       fos = new FileOutputStream(savedFile);       // open the file output stream
       in  =  theURL.openStream();
// read the data - will stop when reach end of stream or error, hopefully!
//       System.out.println("Downloading postscript file "+theFileName+" Please be patient.");
       for(int nbytes=in.read(buffer); nbytes>0; nbytes=in.read(buffer)){
           nByteCount += nbytes;
           fos.write(buffer,0,nbytes);
            }
       fos.close();
       in.close();
       System.out.println("Wrote "+nByteCount+" bytes to "+savedFile.getAbsolutePath());
       guiUtilities.HTMLViewer.getInstance().addImageFile(savedFile.getAbsolutePath());
} 
//************************************************
       public static Hashtable getSignoffDataTestNo(String sn, String location, String signoffType) throws Exception {
         Hashtable thisHash = new Hashtable();
         StringBuffer sqlStat = new StringBuffer("SELECT test_no FROM tests");
         sqlStat.append(" WHERE ser_no="+sn+" AND run_no='"+signoffType+"' AND test_name='bmMOD_RData'");
         if(!location.equals("Any")) sqlStat.append(" AND locn_name='"+location+"'");
         sqlStat.append(" ORDER BY test_date DESC, test_no DESC");
         Statement statement = SCTDBInterface.getInstance().connection.createStatement();
         ResultSet resultSet = statement.executeQuery(sqlStat.toString());
         for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
            if(thisHash.containsKey(location)) continue;
            thisHash.put(location,resultSet.getString(1));
            break;
	    }
//      System.out.println("Retrieved "+recordCount+" names in total.");
      statement.close();
      return thisHash;
      }
//************************************************
       public static Hashtable getSignoffDataTestNo(String sn, String signoffType) throws Exception {
// return vector of test numbers
         Hashtable locationHash = new Hashtable();
         StringBuffer sqlStat = new StringBuffer("SELECT locn_name,test_no FROM tests");
         sqlStat.append(" WHERE ser_no="+sn+" AND run_no='"+signoffType+"' AND test_name='bmMOD_RData'");
         sqlStat.append(" ORDER BY test_date DESC, test_no DESC");
         Statement statement = SCTDBInterface.getInstance().connection.createStatement();
         ResultSet resultSet = statement.executeQuery(sqlStat.toString());
         for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
            String location = resultSet.getString(1);
            String testno = resultSet.getString(2);
            if(locationHash.containsKey(location)) continue;
            locationHash.put(location,testno);
            if(signoffType.equals("FINALSIGNOFF")) break;
	    }
//      System.out.println("Retrieved "+recordCount+" names in total.");
      statement.close();
      return locationHash;
      }
    public static String getUploaderInfo(String testno) throws Exception {
         StringBuffer sqlStat = new StringBuffer("SELECT locn_name,test_date,initls FROM tests");
         sqlStat.append(" WHERE test_no="+testno);
         Statement statement = SCTDBInterface.getInstance().connection.createStatement();
         ResultSet resultSet = statement.executeQuery(sqlStat.toString());
         String returnString=null;
         for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
            String location = resultSet.getString(1);
            String testdate = guiUtilities.DaveUtils.extractDate(resultSet.getString(2));
            String initials = resultSet.getString(3);
            returnString = "Uploaded by "+initials+" from "+location+" on "+testdate;
	    }
      statement.close();
      return returnString;
      }
//**********************************************************
   public static Hashtable testComments(String testno_subQuery) throws Exception {

      Hashtable commentHash = new Hashtable();
      StringBuffer sqlStat = new StringBuffer("SELECT test_no,cmnt_text FROM test_cmnts WHERE test_no IN (SELECT tests.test_no FROM tests ");      
      sqlStat.append(testno_subQuery+")");
//      System.out.println(sqlStat.toString());
     Statement statement = SCTDBInterface.getInstance().connection.createStatement();
     ResultSet resultSet = statement.executeQuery(sqlStat.toString());
     int ncomments=0;
     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          ncomments++;
          if(ncomments%100 ==0) System.out.println("Retrieved "+ncomments+" comments so far...");
          String testno = resultSet.getString(1);
          String comment = resultSet.getString(2);
          // beware of more than one comment in a given testno !
          String newComment = (commentHash.containsKey(testno)) ? (String)commentHash.get(testno)+" "+comment : comment;
          commentHash.put(resultSet.getString(1),newComment);
	    }
      statement.close();
      return commentHash;
      }




   public static Hashtable testImages(String testno_subQuery) throws Exception {
// has contains a vector, and the vector contains title, then url, then title, then url etc
      Hashtable testImageHash = new Hashtable();
      System.out.println("Checking for test images...");
      StringBuffer sqlStat = new StringBuffer("SELECT test_no,title,name FROM test_images WHERE test_no IN (SELECT tests.test_no FROM tests ");      
      sqlStat.append(testno_subQuery+")");

     Statement statement = SCTDBInterface.getInstance().connection.createStatement();
     ResultSet resultSet = statement.executeQuery(sqlStat.toString());
     int ncomments=0;
     Vector imageList;
     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          ncomments++;
          if(ncomments%100 ==0) System.out.println("Retrieved "+ncomments+" test images so far...");
          String testno = resultSet.getString(1);
          String title = resultSet.getString(2);
          String name = resultSet.getString(3);
          // beware of more than one image in a given testno !
          if(testImageHash.containsKey(testno)) imageList = (Vector)testImageHash.get(testno);
          else imageList = new Vector();
          imageList.addElement(title);
          imageList.addElement(name);
          testImageHash.put(testno,imageList);
	    }
      System.out.println("Retrieved "+ncomments+" test images in total.");
      statement.close();
      return testImageHash;
      }

//***********************************************************************************************
   public static void saveImage(String testno, String fileName, File theFile) throws Exception {
      InputStream in;   
      FileOutputStream fos = new FileOutputStream(theFile);               
      byte[] buffer = new byte[128000]; // max size is 128kByte per image (I think!)

     String sqlQuery = "SELECT data FROM test_images WHERE test_no="+testno+" AND name='"+fileName+"'";
     Statement statement = SCTDBInterface.getInstance().connection.createStatement();
     ResultSet resultSet = statement.executeQuery(sqlQuery);

// execute query here
      System.out.println("Retrieving "+fileName+" ...");
     int nByteCount=0;

     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         in  = resultSet.getBinaryStream(1);           // open the data stream

// read the data - will stop when reach end of stream or error, hopefully!
         for(int nbytes=in.read(buffer); nbytes>0; nbytes=in.read(buffer)){

            // System.out.print("Nbytes read : " + nbytes+". ");
            nByteCount += nbytes;
            fos.write(buffer,0,nbytes);  // write the data to the file output
            }
         fos.close();  // close the file output
         System.out.println("Saved image "+fileName+" with size "+nByteCount+" bytes...");
         guiUtilities.HTMLViewer.getInstance().addImageFile(theFile.getAbsolutePath());

         }
     statement.close();
     return;
}

        
     


}