package guiUtilities;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.border.*;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
import java.awt.*;
import java.io.*;
import java.util.*;
import javax.swing.event.TableModelEvent;


public class SpreadsheetViewer extends JFrame implements ActionListener,ListSelectionListener {

    int selectedRow=0;

    JButton saveButton,closeButton;
    JLabel title;
    JScrollPane tableAggregate;
    JTable table;
    myTableAdapter resultTable;

    public SpreadsheetViewer() {
	    super("Spreadsheet");
	    JPanel pane = new JPanel();
            pane.setLayout(new BoxLayout(pane,BoxLayout.Y_AXIS));

            pane.add(Box.createRigidArea(new Dimension(0,15)));
	    title = new JLabel("Title",JLabel.CENTER);
	    title.setFont(new Font("SansSerif",Font.BOLD,14));
            title.setForeground(Color.blue);
            title.setAlignmentX(Component.CENTER_ALIGNMENT);
            pane.add(title);


        // Create the table.

        tableAggregate = createTable();
        tableAggregate.setBorder(new BevelBorder(BevelBorder.LOWERED));

           pane.add(tableAggregate);



            pane.add(Box.createRigidArea(new Dimension(0,5)));

            JPanel buttonPane = new JPanel();
            buttonPane.setLayout(new BoxLayout(buttonPane,BoxLayout.X_AXIS));
            buttonPane.add(Box.createHorizontalGlue());
            saveButton = new JButton("Save Spreadsheet");
            saveButton.addActionListener(this);
            buttonPane.add(saveButton);

            buttonPane.add(Box.createHorizontalGlue());

            closeButton = new JButton("Create Report");
            closeButton.setEnabled(false);
            closeButton.addActionListener(this);
            buttonPane.add(closeButton);



            pane.add(buttonPane);

	      setContentPane(pane);
		pack();

		}



       public void updateResultTable(Vector theData, String caption) {
            title.setText(caption);
            resultTable.reTable(theData);
	    setVisible(true);
            }


	public Insets getInsets() {
		return new Insets(20,20,20,20);
		}

 

    public JScrollPane createTable() {

        JScrollPane scrollPane = new JScrollPane();
        // Create the table
        try {
        resultTable = new myTableAdapter();
        table = new JTable(resultTable);
//	table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF); 
        table.setPreferredScrollableViewportSize(new Dimension(800, 150));
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        ListSelectionModel rowSM = table.getSelectionModel();
        rowSM.addListSelectionListener(this);

        scrollPane = new JScrollPane(table);
        }
        catch (Exception e) {System.out.println("Error "+e.toString());}
        return scrollPane;
    }
   

 



      public void actionPerformed(ActionEvent evt) {
    	    Object source = evt.getSource();
            Vector itemList = new Vector();

    	  if (source == saveButton) {  // save the table in semi-colon delimted spreadsheet file
                 
            if(resultTable.recordCount==0) return;

	    JFileChooser fc;
	    fc = new JFileChooser();
	    int returnVal = fc.showSaveDialog(SpreadsheetViewer.this);
	    if (returnVal != JFileChooser.APPROVE_OPTION) return;
	    File file = fc.getSelectedFile();
            DaveUtils.writeTXT(file,resultTable);
            return;
          }
         if(source==closeButton) setVisible(false);



     }
     public void valueChanged(ListSelectionEvent e) {
          if(e.getValueIsAdjusting()) return;
          ListSelectionModel lsm = (ListSelectionModel)e.getSource();
          if(lsm.isSelectionEmpty()) {
 
            }
          else {
             selectedRow = lsm.getMinSelectionIndex();

             }
          }

}
